<?php

$lang = array (

// Added in RC2

'no_help_file' => "Sorry, we could not locate that help file, please try again.",


//--

// Added in RC1

'no_member_mail' => "Sorry, you are not permitted to send an email via this board",

//--

// Added in Beta 3

'no_vote'  => "You did not choose a poll choice to vote against. Please go back and ensure you click on one of the radio buttons next to the choice you wish to vote for",

//--- End B3 additions ---

'me_no_forum'   => "You don't appear to have any forums to moderate.",


'search_word_short' => "One or all of your search keywords were below <#EXTRA#> characters, please go back and increase the length of these search keywords.",

'no_name_search_results' => "The member name you chose to filter by cannot be found, please go back and try again.",


'split_not_enough' => "You must choose at least one post to split!",

'mt_no_topic'  => "We could not find a topic in the database that matches the URL you entered, please try again and double check the information entered",
'mt_same_topic' => "You cannot merge the same topic, that's just silly",

'forum_no_post_allowed'    => "You cannot move topics into this forum as it does not allow posts to be made",


'no_msn'					=>	"This member does not have a valid MSN Messenger Name.",
'no_yahoo'					=>	"This member does not have a valid Yahoo! Messenger Name",

'cf_to_long'  => "You entered too much data for the field '<#EXTRA#>', please go back and check the input",


'search_flood' => "Sorry, the board administrator has enabled search flood control. Please wait at least <#EXTRA#> seconds before trying again.",

'cal_no_events' => "There are no birthdays or events for that date, please go back and try again.",
'cal_date_oor'   => "The date you have chosen for that event is not a legal date (You may have chosen 30th February for example). Please go back and check your input and try again.",

'cal_title_none' => "You must enter an event title that is longer than 2 characters",
'cal_title_long' => "The event title you entered was too long, please limit it to under 64 characters",

'search_off' => "Sorry, the administrator has taken the search engine offline for the moment. Please try again later",
'reg_off' => "The board administrator is no longer accepting any new registrations at the moment.",

'offline_title' => "Board Offline",
'offline_login' => "If you have permission to access an offline board, please log in below",

'skin_not_found' => "The skin you chose could not be found. It's possible that an administrator has removed the skin, please go back and choose another.",

'no_view_board' => "You do not have permission to view this board",

'forum_read_only' => "This forum is read only, no new posts or replies can be made.",

'no_av_upload'  => "You do not have permission to upload avatars to this server",
'no_av_type'    => "You are not allowed to upload that type of file as an avatar",
'no_av_name'    => "The uploaded file does not have a name, please go back and check your input",

'upload_failed' => "The upload failed. Please contact a member of staff to help rectify the problem",

'er_log_in_title'  => "You are not logged in, you may log in below",
'erl_enter_name'   => "Your account username",
'erl_enter_pass'   => "Your account password",
'erl_log_in_submit' => "Log In",

'er_useful_links'  => "Useful Links",
'er_lost_pass'      => "Forgotten Password Recovery",
'er_register'       => "Register a new account",
'er_contact_admin'  => "Contact the forums administrator",
'er_help_files'      => "Our help documentation",

'no_archive_messages'     => "Sorry, no private messages were found using that search critera. Try again and broaden the scope.",

'no_delete_post'           => "Sorry, you cannot delete the first post in this topic. If you wish to delete the complete topic, choose 'Delete Topic' from your moderator bar at the foot of the topic view screen.",
'exp_text'                  =>  "Sorry, an error occured. If you are unsure on how to use a feature, or don't know why you got this error message, try looking through the help files for more information.",
'msg_head'                  =>  "The error returned was:",

'auth_no_mem'               => "We could not find any member matching the User ID that you entered. Please double check the URL, or the data you entered into the form. If the error persists, please contact a member of staff to assist you.",
'auth_key_wrong'            => "Sorry, the Validation Key is incorrect for this member. Please check the URL or the data you entered into the form. If the error persists, please contact a member of staff to assist you.",
'auth_no_key'               => "Sorry, that member does not have to validate their account. Please double check the data you entered.",

'email_addy_mismatch'       => "Sorry, the email addresses did not match, please go back and check the data you entered.",

'lp_no_pass'                => "Sorry, we do not have a new password for this account in our records, please contact a staff member to rectify the problem",

'val_key_present'           => "This account is already under activation verification for either a new registration, lost password or email address change. Please complete the previous activation before attempting to continue with this one. If you believe this account has been activated or re-activated, please contact a member of staff to rectify the problem",

'complete_form'             => "You must complete the form fully before proceeding. Please go back and check the data you entered.",

forum_no_access					=>	"Sorry, you do not have reading permissions on this forum. If this is a password protected forum, please log into the forum by clicking on the forum link from the board index page.",
name_too_long					=>	"The username you entered was too long",
msg_blocked					=>	"This member has chosen not to be contactable by the board Messenger",
no_msg_title					=>	"You must enter a message title",
reg_link					=>	"Register Now!",
wrong_pass					=>	"Sorry, that was the incorrect password",
poll_no_guests					=>	"Guests cannot vote",
no_such_user					=>	"Sorry, we don't have a member with that name in our records, please try again and double check the data you entered.",
search_no_input					=>	"You must enter a keyword(s) to search by!",
stf_no_msg					=>	"You must enter a message to send",
invite_no_name					=>	"You must enter your name",
poll_none_found					=>	"We could not find that poll",
no_search_id					=>	"No search file ID number was recorded, please try again",
no_guest_new_topics					=>	"sorry, but the board administrator does not allow guests to start new posts in this forum. If you are a registered member please log in",
no_user					=>	"Sorry, we could not find that member",
no_search_words					=>	"You did not enter any keywords to search by",
invalid_login					=>	"Invalid log in. Either your password or your username was not correct. Please go back and double check the information you entered. Please remember that usernames and passwords are case sensitive, so 'PaSSwOrD' is different from 'password'",
web_too_long					=>	"Your website entry is too long.",
stf_no_email					=>	"You must enter the email address of the person you are sending this page to",
mem_id_wrong					=>	"Sorry, but your Member ID is not in the correct format",
forum_off					=>	"Sorry, but this forum has been disabled",
no_newer					=>	"There are no topics newer than this one",
poss_hack_attempt					=>	"We are treating that action as a possible hack attempt, this action will be logged and the board administrator will be informed via email",
not_logged_in					=>	"You are not logged in",
int_too_long					=>	"Your Interests entry is too long.",
no_to_member					=>	"We could not find that member in our database, please check the spelling of the name",
invalid_ext					=>	"You are not allowed to use that image extension on this board. A valid format is: http://www.domain.com/picture.gif, an invalid format is: http://www.domain.com/picture.one.gif",
subject_long					=>	"The email subject was too long",
move_already_moved					=>	"This is the original moved topic and it can't be moved again, if you want to move it again, please choose the topic that was moved into the previous destination forum",
cookie_error					=>	"Sorry, there is a cookie error, please re-log in",
no_attach					=>	"Attachments are not allowed for this forum",
no_aol					=>	"That member does not have a valid AOL Name",
name_too_short					=>	"The username you entered was too short",
missing_files					=>	"Sorry, some required files are missing, if you intended to view a topic, it's possible that it's been moved or deleted. Please go back and try again.",
post_too_long					=>	"Sorry, your post was too long, please reduce it",
locked_topic					=>	"Sorry, this topic has been locked",
flash_url					=>	"That is not a valid Flash URL",
profile_guest					=>	"We could not find this member in our database, it's possible that the member has been removed.",
stf_no_subject					=>	"You must enter a subject for the email",
not_icq_number					=>	"That is not a valid ICQ number",
rp_noemail					=>	"You must enter a valid email address before we can send this report",

upload_to_big					=>	"The file you requested to upload was greater than the limit the administrator has set for your group.",


user_exists					=>	"We already have a member by that name, please choose another",
no_msg_chosen					=>	"You did not select any messages. You select them by clicking on the checkbox on the far right of each entry",
error_back					=>	"Go Back",
log_in_yes					=>	"You are currently logged in as ",
flash_number					=>	"The height and width attributes of the flash tag have to be a number",
no_avatar					=>	"The administrator has disabled avatars on this board",
poll_you_voted					=>	"You have already voted in this poll",
not_url_photo					=>	"That is not a valid URL for your Photo. We do not allow dynamic pages in the IMG tags",
no_action					=>	"Please don't adjust the generated URLs. If you came here in error, please go back and try again",
no_guest_posting					=>	"Sorry, but the board administrator has disabled guest posting in this forum, if you are a registered member - please log in",
invalid_email					=>	"You must enter a VALID email address",
no_start_polls					=>	"You cannot start a poll",
move_no_forum					=>	"You did not choose a destination forum",
no_use_messenger					=>	"You are not allowed to use the messenger feature on this board",
no_msg					=>	"You must enter a message",
no_dynamic					=>	"Sorry, dynamic pages in the [IMG] tags are not allowed",
no_rules_show					=>	"There isn't any FAQ/Rule files for this forum",
membername_none					=>	"Sorry, we could not find an account with that membername",
log_in_now					=>	"Log in Now!",
no_subject					=>	"You did not enter a subject for the email",
pass_too_long					=>	"The password entered was too long",
username_short					=>	"The username you entered was too short",
already_sub					=>	"You are already subscribed to this topic or forum.",
forgot_pass					=>	"Forgotten your password?",
no_older					=>	"There are no topics older than this one",
stf_no_name					=>	"You must enter the name of the person you are sending this page to",
no_view_topic					=>	"You do not have permission to view this topic",
IBForums_error					=>	"Board Error",
no_replies					=>	"Sorry, you do not have permission to reply to that topic",
error_title					=>	"Board Message",
no_chosen_member					=>	"You didn't enter or choose a name to send the message to!",
pass_blank					=>	"Your password field was not complete",
flood_control					=>	"Flood control is enabled on this board, please wait <#EXTRA#> seconds before replying or posting a new topic",
no_message					=>	"You did not enter a message for the email",
member_in_add_book					=>	"You already have that member stored in your address book",
posting_off					=>	"Your posting permissions have been removed",
move_same_forum					=>	"You cannot move this topic into the same forum, well, you could but there wouldn't be a lot of point",
error_txt					=>	"An error has occured",
rp_nomsg					=>	"You must enter a message to the moderators",
too_many_images					=>	"Sorry, but your post contains more the allowed number of images",
invite_no_email					=>	"You must enter your email address",
not_op					=>	"Sorry, you do not have permission to edit that message",
no_poll_reply					=>	"The poll creator has created this as a vote-only topic",
request_hack					=>	"Some of the data did not match our records, we are treating this as a possible hack attempt!",
photo_too_long					=>	"Your Photo field is too long.",
avatar_invalid_ext					=>	"Sorry, that is not a valid file extension",
no_reply_polls					=>	"You cannot vote in this poll",
no_post					=>	"You must enter a post",
calendar_not_all					=>	"Either complete all the birthdate fields, or leave them all blank - we cannot process partial birthdates",
referrer_fail					=>	"Board does not allow offsite posting.",
not_authorised					=>	"Sorry, but you have yet to validate your user account. Please check the email account you registered with.",
memid_blank					=>	"Your member Id field was not complete",
session_id_no_match					=>	"Fatal Error, your session ID cookie does not match any of the data!",
no_email_stored					=>	"Sorry, but we could not find that email address in our records",
topictitle_too_long					=>	"The topic title you entered is too long",
no_such_msg					=>	"That message does not exist",
wrong_name					=>	"Sorry, we could not find a membername matching your input (this could have been from a log in form, or a session authentication).",
too_many_emoticons					=>	"You have posted a message with more emoticons that this board allows. Please reduce the number of emoticons you've added to the message",
no_topic_title					=>	"You must enter a topic title",
guest_abuse					=>	"We could not determine your posting status. Please try logging back in, or if you are a guest - please try again",
password_no_match					=>	"The password is not the same as the data entered",
already_logged_in					=>	"That user is already logged in!",
no_guests					=>	"Sorry, but this function isn't available to guests",
no_permission					=>	"Sorry, but you do not have permission to use this feature. If you are not logged in, you may do so using the form below.",
pass_no_match					=>	"The Two New Passwords do not match",
server_too_busy					=>	"Sorry, the server is too busy to handle your request, please try again in a moment",
loc_too_long					=>	"Your Location entry is too long.",
poll_you_created					=>	"You created this poll",
no_usepm_member					=>	"This message can not be sent because the recipient does not have permission to use the private messenger.",
go_back					=>	"Please go back and correct this error",
log_in_no					=>	"You are NOT logged in",
pass_too_short					=>	"The password entered was too short",
no_register					=>	"Sorry, the board administrator has switched off Registrations",
move_no_topic					=>	"That Topic is not in our Database, it's possible it was deleted",
flash_too_big					=>	"Sorry, but the flash movie you posted was either too large in height, width or both",
end_subs_value					=>	"You must enter a numeric value for the 'End Subscription' field",
no_starting					=>	"Sorry, you do not have permission to start a topic in this forum",
no_search_forum					=>	"You did not choose any forums to search in, or the forums you chose to search in are password protected. If this is the case, please make sure you are logged into the password protected forums before searching.",
not_registered					=>	"Guests cannot peform this action, if you are a registered member, please log-in",
no_icq					=>	"That member does not have a valid ICQ Number",
not_aol_name					=>	"That is not a valid AOL Identity",
private_email					=>	"That member has chosen to keep their email address private",
user_agent_no_match					=>	"You are using a different computer than the one you logged in under.",
poll_add_vote					=>	"Vote!",
you_are_banned					=>	"Sorry, you are not permitted to use this board",
incorrect_use					=>	"Incorrect use of one of the board files",
no_search_results					=>	"Sorry, but we did not find any matches to display. Try again and broaden your search criteria. If you were searching for new posts since your last visit, it's possible that there are none to show.",
request_error					=>	"An error occured, not all of the required fields were sent from the validation link. Please ensure that they whole link was entered, it's possible that your email clients auto-wrapper cut the link in half. Please try again.",
not_yahoo_name					=>	"That is not a valid YAHOO name",
stf_invalid_email					=>	"The email address you entered was of an incorrect format",
pass_link					=>	"Click here!",
no_email					=>	"You must enter an email address to request your log-in details",
max_message_from					=>	"Your Private Messenger box is full. You have reached the limit set for this board. You will need to delete some of your currently saved messages from either your inbox, or your saved items folder.",
cant_use_feature					=>	"You are not allowed to use this part of the board",
memid_too_long					=>	"Your member Id field was too long",
moderate_no_permission					=>	"You do not have permission to carry out that function",
too_many_img					=>	"Sorry, but you have posted more images than you are allowed to",
no_sub_id					=>	"Sorry, we could find that topic subscription",
max_message_to					=>	"That member's Private Messenger box is full and is unable to accept any new messages.",
error_not_registered					=>	"Not Registered? ",
username_long					=>	"The username you entered was too long",
memid_too_short					=>	"Your member Id field was too short",
sig_too_long					=>	"Your signature is too long.",
no_username					=>	"You must enter a username",
no_avatar_selected					=>	"No avatar was selected, please go back and correct this error",
incorrect_avatar					=>	"Sorry, but that is not a valid avatar",
avatar_invalid_url					=>	"Sorry, but the URL you entered for your avatar was incorrectly formatted.",
rp_noname					=>	"You must enter your name before we can send this report",
illegal_img_ext					=>	"Sorry, but you cannot use that file extension for an image tag",
cannot_remove_dir					=>	"You cannot remove that virtual directory",
email_exists					=>	"That email address cannot be used as it is already in our records",
please_complete_form					=>	"Please complete the form fully before submitting it",
invite_no_email_f					=>	"You must enter an email address for your friend",
move_no_source					=>	"No source forum was chosen",
log_in					=>	"Not Logged in?",
data_incorrect					=>	"One of the data fields contained the incorrect type of data, please double check the URL or data you entered into the form",
);
?>